// Bjrk Boye Busch - december 2008
using System;
using System.Collections.Generic;
using System.Text;
using Model_Syntakstr;
using TokenLibrary;

namespace Parser_Regelbaseret
{
    public class Parser
    {
        // data for input og input-styring
        private Queue<RuteToken> tokenQueue;    // liste og en positionsvariabel kunne bruges som alternativ

        private RegionsKreplan regionsKreplan = new RegionsKreplan();
        private Kreplan opsamlingsKreplan;    // arbejdsobjekt til opsamling af elementer under parsing
        private Afgang opsamlingsAfgang;        // arbejdsobjekt til opsamling af elementer under parsing

        public Parser(ICollection<RuteToken> input_CollectionOfTokens)
        {
            tokenQueue = new Queue<RuteToken>(input_CollectionOfTokens);
            tokenQueue.Enqueue(new RuteToken(RuteToken.TokenType.Slut, ""));  // st slut hvis mangler
        }
        // De nste 2 metoder er for i resten at kunne undg at forholde sig til styring af inputet
        // Her hvor der bruges en queue kunne disse metoder dog let undvres, da der kun skal kunne ses en token frem
        // (uden den fjernes) og desuden flyttes en token frem
        private RuteToken First
        {
            get { return this.tokenQueue.Peek(); }
        }
        private void Next()          // Flytter en plads
        {
            tokenQueue.Dequeue();   // Vrdi aflses ikke da det ikke er ndvendig
        }
        public RegionsKreplan GetRegionsKreplan()
        {
            return this.regionsKreplan;
        }

        //----------------------------------------------------------------------------------
        public bool Parse()
        {
            return StartRegionskreplan();
        }

        private bool StartRegionskreplan()
        {
            bool ok = true;
            while (First.Typen != RuteToken.TokenType.Slut)
            {
                if (! StartKreplan())      // ikke krt ok ?
                {
                    while (First.Typen != RuteToken.TokenType.NummerTegn &&
                            First.Typen != RuteToken.TokenType.Slut)
                    {
                        Console.WriteLine("Token skippet " + First);
                        Next();
                    }
                    ok = false;
                }
            }
            return ok;
        }

        private bool StartKreplan()
        {
            this.opsamlingsKreplan = new Kreplan();

            if (First.Typen != RuteToken.TokenType.NummerTegn)
            {
                Console.WriteLine("Fejl i start p kreplan # forventet  - token " + First);
                return false;
            }

            Next();

            if (First.Typen != RuteToken.TokenType.ToCifretTal && First.Typen != RuteToken.TokenType.TreCifretTal)
            {
                Console.WriteLine("Fejl i rutenr 2- eller 3-cifret tal forventet  - token " + First);
                return false;
            }
            int nr = int.Parse(First.Leksem);
            if (nr <= 0)
            {
                Console.WriteLine("Fejl i rutenr skal vree strre end 0  - token " + First);
                return false;
            }

            this.opsamlingsKreplan.Nr = nr;
            Next();

            do
            {
                if (!StartAfgang()) return false;         // ved fejl return
            } while (First.Typen == RuteToken.TokenType.Bynavn);

            this.regionsKreplan.TilfjKreplan(this.opsamlingsKreplan);

            return true; // Det gik godt
        }

        private bool StartAfgang()
        {
            this.opsamlingsAfgang = new Afgang();

            if (First.Typen != RuteToken.TokenType.Bynavn)
            {
                Console.WriteLine("Fejl i bynavn / manglende afgang - token " + First);
                return false;
            }

            this.opsamlingsAfgang.Bynavn = First.Leksem;
            Next();

            if (First.Typen != RuteToken.TokenType.ToCifretTal)
            {
                Console.WriteLine("Fejl i time: 2-cifret tal forventet  - token " + First);
                return false;
            }
            int time = int.Parse(First.Leksem);
            if (time > 23)
            {
                Console.WriteLine("Fejl i timeangivelse (skal vre 0-23  - token " + First);
                return false;
            }
            this.opsamlingsAfgang.Time = time;
            Next();

            if (First.Typen != RuteToken.TokenType.Kolon)
            {
                Console.WriteLine("Fejl efter time: ':' forventet  - token " + First);
                return false;
            }
            Next();

            if (First.Typen != RuteToken.TokenType.ToCifretTal)
            {
                Console.WriteLine("Fejl i minut: 2-cifret tal forventet  - token " + First);
                return false;
            }
            int minut = int.Parse(First.Leksem);
            if (minut > 59)
            {
                Console.WriteLine("Fejl i minutangivelse (skal vre 0-59  - token " + First);
                return false;
            }
            this.opsamlingsAfgang.Minut = minut;
            Next();

            this.opsamlingsKreplan.TilfjAfgang(this.opsamlingsAfgang);
            
            return true;        // Det gik godt
        }
    }
}
